//OPROGRAMOWANIE NANOdds v.1.2 by SP8QEP DO UŻYTKU NIEKOMERCYJNEGO sp8qep@gmail.com 
//-------------fusebity - praca z wewnętrznym oscylatorem--------------------
//EXTENDED 0xFF
//HIGH 0XDA
//LOW 0XC2
//---------------------------------------------------------------------------
#include <Arduino.h>
#include <EEPROM.h>
//----------AD9833-----------------------------------------------------------
#define AD9833_F_MCLK 24000000          // 24MHz generator taktujący AD9833
#define AD9833_2POW28 268435456         
#define FSYNC 7 // DAT  D11 // CLK  D13 //porty do których podłączony jest AD9833 (11 i 13 to sprzętowe SPI)
//----------ENKODEr----------------------------------------------------------
#include <Rotary.h>
Rotary rotary = Rotary(2, 3); //enkoder podłączamy do pinów 2 i 3
#include <SPI.h>

//---------------------------------------------------------------------------
long save=0; //zmienna pomocnicza
long savetime=10000; //ilość wykonań pętli głównej po przekroczeniu której nastąpi zapis parametrów do EEPROMu

//---------------------------------------------------------------------------
int SW = 0; //nr portu do którego jest podłączony przycisk enkodera
int LED = 5; //nr portu do którego jest podłączona dioda LED
int LED1 = 6; //nr portu do którego jest podłączona dioda LED1
long krok; //krok przestrajania
double freq;//aktualna częstotliwość wyświetlana na wyświetlaczu; faktycznie generowana częstotliwość może być inna o wartość freqbfo i vfocorr

//----------------WARTOŚCI POCZĄTKOWE---------------------------------------
double frequency = 3700000; //7150000; //częstotliwość początkowa (synteza wraca do niej po dłuższym przyciśnięciu enkodera)
double freqbfo = 0;//9999250; //częstotliwość pośrednia TRX
double BandBegin = 3500000; //100000; //początek pasma
double BandEnd = 3800000; //30000000; //koniec pasma
double vfocorr = 0; //-120; //korekta częstotliwości

//---------------------------------------------------------------------------
void setup(){
  delay(40);
  pinMode(FSYNC, OUTPUT); digitalWrite(FSYNC, HIGH);  pinMode(SW, INPUT_PULLUP); 
  pinMode(LED, OUTPUT); digitalWrite(LED,LOW); pinMode(LED1, OUTPUT); digitalWrite(LED1,LOW);
  readParameters();
  InitVFO(); 
  if (krok==50) {digitalWrite(LED,HIGH); digitalWrite(LED1,HIGH);} else if (krok==500) {digitalWrite(LED,LOW); digitalWrite(LED1,LOW);}
  attachInterrupt(0, rotate, CHANGE); attachInterrupt(1, rotate, CHANGE);
}//setup

//---------------------------------------------------------------------------

void loop() {
  save++;
  int psw = digitalRead(SW);
  int i = 0;
  if (psw==0 ) 
    {
      save=0;
      do {psw = digitalRead(SW); i++; delay(10);} while (psw==0 and i<101);
      
      if (i>100)  {freq=frequency; freq = float( long(freq / krok)) * krok; SetVFO();  i = 0; do {psw = digitalRead(SW);} while (psw==0); delay(10);} 
      else
      if (krok==500 and i<100) {krok=50; SetVFO(); i = 0; digitalWrite(LED,HIGH); digitalWrite(LED1,HIGH); do {psw = digitalRead(SW);} while (psw==0);}
      else 
      if (krok==50 and i<100)  {krok=500;  freq = float( long(freq / krok)) * krok; SetVFO();  i = 0; digitalWrite(LED,LOW); digitalWrite(LED1,LOW); do {psw = digitalRead(SW);} while (psw==0);}
    } 
    if (save==savetime) {saveParameters();} else if (save>savetime+1000) {save=savetime+1;}
}//loop

//---------------------------------------------------------------------------
void rotate() {
  unsigned char result = rotary.process();
      if (result == DIR_CW)  {freq+=krok; if (freq>BandEnd) {freq=BandBegin; } } else 
      if (result == DIR_CCW) {freq-=krok; if (freq<BandBegin) {freq=BandEnd; } } ;
      freq = float( long(freq / krok)) * krok; 
      SetVFO();  
      save=0;
}//end rotate



